
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *tPlane3D_class;
void *tPlane3D_class;

typedef struct _tPlane3D {
  t_object  x_obj;

// pd code: 
//   t_float   X, Y, Z, VX, VY, VZ, P, distance_old;
  float   X, Y, Z, VX, VY, VZ, P, distance_old;

// pd code: 
//   t_outlet *force_new, *profondeur, *vitesse;// outlet
  void *force_new, *profondeur, *vitesse;// outlet
} t_tPlane3D;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
void tPlane3D_position3D(t_tPlane3D *x, double X,  float Y, double Z);
void tPlane3D_setXYZ(t_tPlane3D *x, double X, double Y, double Z);
void tPlane3D_setVXYZ(t_tPlane3D *x, double X, double Y, double Z);
void tPlane3D_setVX(t_tPlane3D *x, double X);
void tPlane3D_setVY(t_tPlane3D *x, double Y);
void tPlane3D_setVZ(t_tPlane3D *x, double Z);
void tPlane3D_setX(t_tPlane3D *x, double X);
void tPlane3D_setY(t_tPlane3D *x, double Y);
void tPlane3D_setZ(t_tPlane3D *x, double Z);
void tPlane3D_setP(t_tPlane3D *x, double X);
void *tPlane3D_new(t_symbol *s, int argc, t_atom *argv);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----



// pd code: 
// void tPlane3D_position3D(t_tPlane3D *x, t_float X,  t_float Y, t_float Z)
void tPlane3D_position3D(t_tPlane3D *x, double X,  float Y, double Z)
{

// pd code: 
// t_float d, tmp, profondeur, vitesse;
float d, tmp, profondeur, vitesse;

		tmp = sqrt (x->VX*x->VX + x->VY*x->VY + x->VZ*x->VZ);
	if (tmp != 0)
	{
		x->VX /= tmp;
		x->VY /= tmp;
		x->VZ /= tmp;

	}
	else
	{
		x->VX=1;
		x->VY=0;
		x->VZ=0;
	}

		d = x->VX * x->X  + x->VY * x->Y + x->VZ * x->Z;

		profondeur = x->VX * X + x->VY * Y + x->VZ * Z - d;

		vitesse = profondeur - x->distance_old ;

		x->distance_old = profondeur;

		outlet_float(x->vitesse, vitesse);

		outlet_float(x->profondeur, profondeur);


		if ( (profondeur < 0) & (profondeur > - x->P) )
		{
			outlet_float(x->force_new, 1);
		}
		else
		{
			outlet_float(x->force_new, 0);
		}

}


// pd code: 
// void tPlane3D_setXYZ(t_tPlane3D *x, t_float X, t_float Y, t_float Z)
void tPlane3D_setXYZ(t_tPlane3D *x, double X, double Y, double Z)
{
  x->X= X;
  x->Y= Y;
  x->Z= Z;
}

// pd code: 
// void tPlane3D_setVXYZ(t_tPlane3D *x, t_float X, t_float Y, t_float Z)
void tPlane3D_setVXYZ(t_tPlane3D *x, double X, double Y, double Z)
{
  x->VX= X;
  x->VY= Y;
  x->VZ= Z;
}


// pd code: 
// void tPlane3D_setVX(t_tPlane3D *x, t_float X)
void tPlane3D_setVX(t_tPlane3D *x, double X)
{
  x->VX= X;
}


// pd code: 
// void tPlane3D_setVY(t_tPlane3D *x, t_float Y)
void tPlane3D_setVY(t_tPlane3D *x, double Y)
{
  x->VY= Y;
}


// pd code: 
// void tPlane3D_setVZ(t_tPlane3D *x, t_float Z)
void tPlane3D_setVZ(t_tPlane3D *x, double Z)
{
  x->VZ= Z;
}

// pd code: 
// void tPlane3D_setX(t_tPlane3D *x, t_float X)
void tPlane3D_setX(t_tPlane3D *x, double X)
{
  x->X= X;
}


// pd code: 
// void tPlane3D_setY(t_tPlane3D *x, t_float Y)
void tPlane3D_setY(t_tPlane3D *x, double Y)
{
  x->Y= Y;
}


// pd code: 
// void tPlane3D_setZ(t_tPlane3D *x, t_float Z)
void tPlane3D_setZ(t_tPlane3D *x, double Z)
{
  x->Z= Z;
}


// pd code: 
// void tPlane3D_setP(t_tPlane3D *x, t_float X)
void tPlane3D_setP(t_tPlane3D *x, double X)
{
  x->P= X;
}


void *tPlane3D_new(t_symbol *s, int argc, t_atom *argv)
{

// pd code: 
//   t_tPlane3D *x = (t_tPlane3D *)pd_new(tPlane3D_class);
  t_tPlane3D *x = (t_tPlane3D *)newobject(tPlane3D_class);


// pd code: ***UNCHANGED*** 
//   x->force_new=outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->profondeur=outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->vitesse=outlet_new(&x->x_obj, 0);
x->vitesse=outlet_new(&x->x_obj, 0);
x->profondeur=outlet_new(&x->x_obj, 0);
x->force_new=outlet_new(&x->x_obj, 0);

  x->distance_old = 0;

  if (argc>=7)
    x->P= atom_getfloatarg(6, argc, argv);
  else
    x->P= 10000;

    if (argc>=6)
    x->Z= atom_getfloatarg(5, argc, argv);
  else
    x->Z= 0;

    if (argc>=5)
    x->Y= atom_getfloatarg(4, argc, argv);
  else
    x->Y= 0;

  if (argc>=4)
    x->X= atom_getfloatarg(3, argc, argv);
  else
    x->X= 0;

  if (argc>=3)
    x->VZ= atom_getfloatarg(2, argc, argv);
  else
	x->VZ= 0;

  if (argc>=2)
    x->VY= atom_getfloatarg(1, argc, argv);
  else
	x->VY= 0;

  if (argc>=1)
	x->VX= atom_getfloatarg(0, argc, argv);
  else
	x->VX= 1;

  return (x);
}


// pd code: 
// void tPlane3D_setup(void) 
void main(void)
{

// pd code 
/*
  tPlane3D_class = class_new(gensym("tPlane3D"),
        (t_newmethod)tPlane3D_new,
        0, sizeof(t_tPlane3D),
        CLASS_DEFAULT, A_GIMME, 0);*/
setup((t_messlist **) &tPlane3D_class,(method)tPlane3D_new,0,(short)sizeof(t_tPlane3D),0L, A_GIMME,0);



// pd code: 
//   class_addcreator((t_newmethod)tPlane3D_new, gensym("pmpd.tPlane3D"),  A_GIMME, 0);
  // class_addcreator ((t_newmethod)tPlane3D_new, gensym("pmpd.tPlane3D"),  A_GIMME, 0);
 

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_position3D, gensym("position3D"), A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)tPlane3D_position3D, "position3D", A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);


// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setVX, gensym("setVX"), A_DEFFLOAT, 0);
addmess((method)tPlane3D_setVX, "setVX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setVY, gensym("setVY"), A_DEFFLOAT, 0);
addmess((method)tPlane3D_setVY, "setVY", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setVZ, gensym("setVZ"), A_DEFFLOAT, 0);
addmess((method)tPlane3D_setVZ, "setVZ", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setX, gensym("setX"), A_DEFFLOAT, 0);
addmess((method)tPlane3D_setX, "setX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setY, gensym("setY"), A_DEFFLOAT, 0);
addmess((method)tPlane3D_setY, "setY", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setZ, gensym("setZ"), A_DEFFLOAT, 0);
addmess((method)tPlane3D_setZ, "setZ", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setXYZ, gensym("setXYZ"), A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)tPlane3D_setXYZ, "setXYZ", A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setVXYZ, gensym("setVXYZ"), A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)tPlane3D_setVXYZ, "setVXYZ", A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(tPlane3D_class, (t_method)tPlane3D_setP, gensym("setPmax"), A_DEFFLOAT, 0);
addmess((method)tPlane3D_setP, "setPmax", A_DEFFLOAT, 0);


}
